//+------------------------------------------------------------------+
//|                                                 ViniI_MTF_ZZ.mq4 |
//|                     Copyright  2011, Victor Niclolaev aka Vinin |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Victor Niclolaev aka Vinin"
#property link      "vinin@mail.ru"

#property indicator_chart_window
#property indicator_buffers 8

#property indicator_color1 Red         // M1
#property indicator_width1 1

#property indicator_color2 Orange      // M5
#property indicator_width2 1

#property indicator_color3 Yellow       // M15
#property indicator_width3 1

#property indicator_color4 Green       // M30
#property indicator_width4 1


#property indicator_color5 Red         // H1
#property indicator_width5 2

#property indicator_color6 DarkTurquoise   // H4
#property indicator_width6 2

#property indicator_color7 Blue       // D1
#property indicator_width7 3

#property indicator_color8 Purple        // W1
#property indicator_width8 4

//---- ZZ parameters
extern int _Depth = 12;
extern int _Dev = 5;
extern int _BStep = 3;

//---- indicator buffers
double M1_ZZ[], M5_ZZ[], M15_ZZ[], M30_ZZ[],H1_ZZ[], H4_ZZ[], D1_ZZ[], W1_ZZ[];

int TimeFrame[]={PERIOD_M1, PERIOD_M5, PERIOD_M15, PERIOD_M30, PERIOD_H1, PERIOD_H4, PERIOD_D1, PERIOD_W1};
int start=8;

int init()
{

   for( int i = 0; i < 8; i++)   {SetIndexStyle( i, DRAW_SECTION );SetIndexEmptyValue( i, 0.0 );}
   
   switch (Period()) {
      case (PERIOD_M1 ):    {SetIndexBuffer( 0, M1_ZZ ); start--;}
      case (PERIOD_M5 ):    {SetIndexBuffer( 1, M5_ZZ ); start--;}
      case (PERIOD_M15):    {SetIndexBuffer( 2, M15_ZZ); start--;}
      case (PERIOD_M30):    {SetIndexBuffer( 3, M30_ZZ); start--;}
      case (PERIOD_H1):     {SetIndexBuffer( 4, H1_ZZ ); start--;}
      case (PERIOD_H4):     {SetIndexBuffer( 5, H4_ZZ ); start--;}
      case (PERIOD_D1):     {SetIndexBuffer( 6, D1_ZZ ); start--;}
      case (PERIOD_W1):     {SetIndexBuffer( 7, W1_ZZ ); start--;}
   }

   IndicatorShortName( "ZigZag(" + _Depth + "," + _Dev + "," + _BStep + ")" );
   
   return( 0 );
}

int deinit()
{
   return( 0 );
}

//   ,   H1,      
int convertShift( int sh, int toTF )
{
   datetime time = Time[sh];
   return( iBarShift( NULL, toTF, time, true ) );
}


double ZZ( int period, int shift )
{
   return( iCustom( NULL, period, "ZigZag_Rosh", 
                    _Depth, _Dev, _BStep, 
                    0, shift ) );
}


int start()
{
//   int    counted_bars=IndicatorCounted();
   int i,j;
   double ZZ[]={0,0,0,0,0,0,0,0};
   for( i = Bars - 1; i >= 0; i-- ) {
      ArrayInitialize(ZZ,0.0);
      for (j=start;j<8;j++) {
         int shift=convertShift(i,TimeFrame[j]);
         ZZ[j]=ZZ( TimeFrame[j], shift );
         if (ZZ[j]==0.0) break;
      }
      switch (Period()) {
         case (PERIOD_M1 ):    M1_ZZ[i] = ZZ[0];
         case (PERIOD_M5 ):    M5_ZZ[i] = ZZ[1];
         case (PERIOD_M15):    M15_ZZ[i]= ZZ[2];
         case (PERIOD_M30):    M30_ZZ[i]= ZZ[3];
         case (PERIOD_H1):     H1_ZZ[i] = ZZ[4];
         case (PERIOD_H4):     H4_ZZ[i] = ZZ[5];
         case (PERIOD_D1):     D1_ZZ[i] = ZZ[6];
         case (PERIOD_W1):     W1_ZZ[i] = ZZ[7];
      }
   }   
   return( 0 );
}